
package de.ivu.elect.presentation.gebietsbaum.exchange;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.exchange.control.AbstractExporter;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsgruppierungExporter;
import de.ivu.elect.business.gebietsbaum.control.GebietsgruppierungExportContext;
import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractExportSearchView;
import de.ivu.elect.presentation.exchange.ExportDescription;

@Named(GebietsgruppierungExportView.COMPONENT_NAME)
@View(viewId = GebietsgruppierungExportView.VIEW_ID, useCase = UseCasePermission.GEBIETSGRUPPIERUNG_EXPORTIEREN)
public class GebietsgruppierungExportView extends AbstractExportSearchView<List<Gebietsgruppierung>, GebietsgruppierungExportContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsgruppierungExportView";

  public static final String VIEW_ID = "/gebietsbaum/gebietsgruppierung-export.xhtml";

  @Inject
  private transient GebietsgruppierungExporter exporter;

  @Inject
  private transient GebietsgruppierungExportDescription exportDescription;

  public GebietsgruppierungExportView() {
    super();
  }

  @Override
  protected AbstractExporter<List<Gebietsgruppierung>, GebietsgruppierungExportContext> getExporter() {
    return exporter;
  }

  @Override
  protected GebietsgruppierungExportContext getContext() {
    if (isWahlSelected()) {
      return new GebietsgruppierungExportContext(getSelectedWahl());
    }

    return new GebietsgruppierungExportContext(getSelectedWahltermin());
  }

  @Override
  public ExportDescription getExportDescription() {
    return exportDescription;
  }
}
